/*
**      QueryPL copyright 1995-96 by kravietZ
**
*/

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#ifdef __MSDOS__
#include <sys\stat.h>
#include <io.h>
#endif

#ifdef __unix__
#include <sys/file.h>
#include <sys/stat.h>
#include <glob.h>
#include <unistd.h>
#endif

#include "polish.h"                    /* min. wer. 4.3.20 */
#include "opts.h"
#include "version.h"
#define BUF_SIZE (4*1024)              /* bufor 4K */
#define CSTCNT (PSTCNT-1)              /* nie bierzemy pod uwage BezPolsk */
#define T_LEN (CSTCNT*PCHCNT+CSTCNT)   /* trzeba policzyc dodatkowo zera */

typedef unsigned char ubyte;

/* 
   wagi zostaly okreslone na podstawie zliczen polskich znakow w pliku 
   zlozonym z kilku polskojezycznych tekstow o lacznej dlugosci 500KB
*/

ubyte o_verb=0, o_batch=0, o_stdout;
int wyn[CSTCNT];
int licznik[T_LEN];
char ibuf[BUF_SIZE], obuf[BUF_SIZE];
int ibuf_ptr = 0, obuf_ptr = 0, ibuf_lim = 0;
int f_in, rargc1,i,res;

#ifdef __unix__
glob_t globbuf;
struct stat statbuf;
#endif

char getxx(void)
{
  if (ibuf_ptr >= ibuf_lim)                 /* odebrane wszystkie? */
  {
    ibuf_lim = read(f_in, ibuf, BUF_SIZE);  /* czytaj z pliku */
    if (ibuf_lim == 0) return 0;            /* nie ma wiecej w pliku */
    ibuf_ptr = 0;                           /* inicjuj wskaznik znakow */
  }
  return ibuf[ibuf_ptr++];                  /* daj znak, zwieksz wskaznik */
}

void ListC(int num1)
{   int i;
    for(i=0;i<PCHCNT;i++) fprintf(stdout,"%2u ",licznik[(num1*(PCHCNT+1))+i]);
    fprintf(stdout," (%u)",wyn[num1]);

    /* do wygrywajacego dopisz gwiazdke '*' */
    if(res == num1) fprintf(stdout," *");
} /* listc */

void DispQH(void)
{
fprintf(stderr,"[QueryPL] by kravietZ, " QPL_VER 
" rozpoznawanie standardu polskich liter. Freeware.\n\n");
fprintf(stderr,"\
Skladnia: qpl [-] [plik plik2 ...] [-v | -b]\n\
Opcje   :\n\
        -v  wyczerpujacy raport\n\
        -b  wynik w postaci parametru ConvPL (stdout)\n\
\nSzczegoly w dokumentacji (qpl.txt).\n");
} /* dispqh */

int QueryFile(char *qfname)
{

/* wagi poszczegolnych znakow */
int wagi[PCHCNT]={1,1,1,1,1,1,1,1,1,15,10,16,19,1,13,13,1,18}; 

int i,j,wynik1,sum1,ind1;
long dlug1=0;
char znaki[]="bokjc675d2l834m9h1anigef"; /* konwersja dla opcji -b */
char ch1;


ibuf_ptr = obuf_ptr = ibuf_lim = 0;

if( strcmp(qfname,"stdin") == 0 ) f_in=STDIN_FILENO;

        else

        {

        stat(qfname, &statbuf);

        if(S_ISDIR(statbuf.st_mode)) return;

        else
        f_in=open(qfname, O_RDONLY

#ifdef __MSDOS__
       |O_BINARY
#endif
        );

        }

           
if( f_in == -1) { perror(qfname); return(254); }

    else /* open ok */

    {

/* inicjalizacja licznikow */
for(i=0;i<T_LEN;i++) licznik[i]=0;

        while( (ch1=getxx()) != 0)
        { 
            dlug1++;
            if( (ubyte) ch1>127) /* po co sprawdzac zwykle znaki? */
               for(i=0;i<T_LEN;i++)
                 if( ( (ubyte) ch1 == *(p_Ami+i)) ) licznik[i]++;
        } /* end zliczanie znakow */

/* zamkniecie pliku wejsciowego, jesli nie stdin */
if( f_in != STDIN_FILENO ) close(f_in);

    for(i=0;i<CSTCNT;i++)
    {
        sum1=0;
        for(j=0;j<PCHCNT;j++)
        {
            ind1=(i*(PCHCNT+1))+j;

           licznik[ind1]=licznik[ind1]*wagi[j]; /* dawna statystyka -s */

            sum1=sum1+licznik[ind1];
        }

        wyn[i]=sum1;

     } /* end zliczanie licznikow */

    wynik1=0;

    /* szukaj najwiekszego wyniku */
    for(i=0;i<CSTCNT;i++) if(wyn[i] > wynik1) { wynik1=wyn[i]; res=i; }

    if(wynik1==0) res=255; /* jesli nie ma zadnych polskich znakow */

/* raport -v */

    if(o_verb) /* opcja -b wylacza opcje -v, podobnie przy >1 pliku */
    {
      fprintf(stdout,"\n\
Tabela zgodnosci znalezionych w tekscie znakow z roznymi standardami\n\n\
W kazdym wierszu znajduje sie 18 zliczen - dla kazdego polskiego znaku\n\
diakrytycznego. W nawiasie na koncu podana jest suma zliczen.Kazde zliczenie\n\
jest dodatkowo mnozone przez odpowiadajaca mu wage. Szczegoly algorytmu\n\
znajdziesz w dokumentacji.\n\n");
      fprintf(stdout,"\nAmiga PL    : "); ListC(0);
      fprintf(stdout,"\nATM         : "); ListC(1);
      fprintf(stdout,"\nCalamus     : "); ListC(2);
      fprintf(stdout,"\nCorel 2.0   : "); ListC(3);
      fprintf(stdout,"\nCP/J        : "); ListC(4);
      fprintf(stdout,"\nCSK         : "); ListC(5);
      fprintf(stdout,"\nCyfromat    : "); ListC(6);
      fprintf(stdout,"\nDHN         : "); ListC(7);
      fprintf(stdout,"\nAmiga FAT   : "); ListC(8);
      fprintf(stdout,"\nFidoMazovia : "); ListC(9);
      fprintf(stdout,"\nFX          : "); ListC(10);
      fprintf(stdout,"\nIEA         : "); ListC(11);
      fprintf(stdout,"\nCP852       : "); ListC(12);
      fprintf(stdout,"\nISO-8859-2  : "); ListC(13);
      fprintf(stdout,"\nKWK         : "); ListC(14);
      fprintf(stdout,"\nLogic       : "); ListC(15);
      fprintf(stdout,"\nMacintosh   : "); ListC(16);
      fprintf(stdout,"\nMazovia     : "); ListC(17);
      fprintf(stdout,"\nMicrovex    : "); ListC(18);
      fprintf(stdout,"\nMS Works    : "); ListC(19);
      fprintf(stdout,"\nTeX PL      : "); ListC(20);
      fprintf(stdout,"\nVentura     : "); ListC(21);
      fprintf(stdout,"\nCP1250      : "); ListC(22);
      fprintf(stdout,"\nAmiga XJP   : "); ListC(23);
      fprintf(stdout,"\n");
    } /* o_verb */

/* wypisz linike */

if (!o_batch) fprintf(stderr,"%-25s%-10ld",qfname,dlug1 );

if (!o_batch) switch(res)
   {
   case 0:  fprintf(stderr,"Amiga PL\n"); break;
   case 1:  fprintf(stderr,"ATM\n"); break;
   case 2:  fprintf(stderr,"Calamus\n"); break;
   case 3:  fprintf(stderr,"Corel 2.0\n"); break;
   case 4:  fprintf(stderr,"CP/J (Elwro 800 Junior)\n"); break;
   case 5:  fprintf(stderr,"CSK\n"); break;
   case 6:  fprintf(stderr,"Cyfromat\n"); break;
   case 7:  fprintf(stderr,"DHN (lub Logic)\n"); break;
   case 8:  fprintf(stderr,"Amiga FAT\n"); break;
   case 9:  fprintf(stderr,"FidoMazovia\n"); break;
   case 10: fprintf(stderr,"FX (lub KWK)\n"); break;
   case 11: fprintf(stderr,"IEA\n"); break;
   case 12: fprintf(stderr,"CP852 (IBM-Latin-2)\n"); break;
   case 13: fprintf(stderr,"ISO-8859-2 (ISO-Latin-2)\n"); break;
   case 14: fprintf(stderr,"KWK (lub FX)\n"); break;
   case 15: fprintf(stderr,"Logic (lub DHN)\n"); break;
   case 16: fprintf(stderr,"Macintosh\n"); break;
   case 17: fprintf(stderr,"Mazovia\n"); break;
   case 18: fprintf(stderr,"Microvex\n"); break;
   case 19: fprintf(stderr,"MS Works\n"); break;
   case 20: fprintf(stderr,"TeX PL\n"); break;
   case 21: fprintf(stderr,"Ventura\n"); break;
   case 22: fprintf(stderr,"CP1250 (Windows 3.0 EE)\n"); break;
   case 23: fprintf(stderr,"Amiga XJP\n"); break;
   default: fprintf(stderr,"(brak polskich znakow)\n"); break;
    } /* switch */

/* wyrzuca parametr dla ConvPL, jesli brak polskich liter to 0 */
   if(o_batch) {
             if(res != 255)
                        {
/*                          fprintf(stderr,"ConvPL         : "); */
                          fprintf(stdout,"%c",znaki[res]);
                        }
                        else fprintf(stdout,"0");
                }

   } /* end open ok */

    return(0);

} /* queryfile */

int main(argc,argv)
int argc;
char **argv;
{
rargc1 = rargc;

if( gopt2("--help") || gopt2("-h") || gopt2("-?") ) { DispQH(); exit(1); }

if(gopt2("-v")) o_verb++;
if(gopt2("-b")) o_batch++; 

if(o_verb&&o_batch) { 
                    fprintf(stderr,"uwaga: opcja -v nie moze byc \
uzywana razem z -b (wylaczam -v)\n");
                    o_verb=0;
                    }

if(rargc1<2) 
             { 
               if(gopt2("-")) { o_stdout=1; exit(QueryFile("stdin")); } 
               else { 
                    DispQH(); exit(1); 
                    }
             }


        else

{       

if (!o_batch) fprintf(stderr,"[QueryPL] by kravietZ, " QPL_VER 
" rozpoznawanie standardu polskich liter. Freeware.\n\n");
if (!o_batch) 
   fprintf(stderr,"Nazwa:                   Dlugosc:  Wykryty standard:\n");

                /* rozwin pierwszy argument */

                if(glob(garg(1), 0, NULL, &globbuf) != 0) 

                    if(globbuf.gl_pathc==0) 

                    { 

                    if(rargc1<=2) 

                     {

                     fprintf(stderr,"zly wzorzec: %s\n", garg(1));

                     return(1);

                     }

                    }

                else

                perror("globfirst");                

if(globbuf.gl_pathc > 1)
{
if(o_batch) fprintf(stderr,"uwaga: opcja -b nie dziala przy"
                           " wielu plikach (wylaczam -b)\n");

if(o_verb) fprintf(stderr,"uwaga: opcja -v nie dziala przy"
                          " wielu plikach (wylaczam -v)\n");
o_verb = o_batch = 0;
}

                if (rargc1>2) 
                { 
                    
                    for(i=2; i<rargc1; i++) 
                     glob(garg(i), GLOB_APPEND, NULL, &globbuf);

                }




                for(i=0; i<globbuf.gl_pathc; i++) 
                                             QueryFile(globbuf.gl_pathv[i]);
}

return(0);
} /* main */
